PL/SQL

Blok PL/SQL:

DECLARE
	deklaracje
BEGIN
	instrukcje
EXCEPTION
	obsuga wyjtkw
END;

Deklaracje zmiennych:

	Identyfikator TYP [NOT NULL] [:=wyraenie];
	np.: nazwisko VARCHAR2(30) := Kowalski;

SELECT w PL/SQL:

SELECT wyraenie1, wyraenie2, ...
INTO zmienna1, zmienna2, ...
FROM ...

	Zapytanie musi zwraca 1 wiersz.

Warunki:

IF warunek THEN
	instrukcje
ELSIF warunek THEN
	instrukcje
ELSE
	instrukcje
END IF;

Wczenie wywietlania komunikatw:

	SET ServerOutput ON

Wywietlenie komunikatu:

	DBMS_OUTPUT.PUT_LINE(napis);

Wywoanie bdu:

	Np. raise_application_error(-20500, komunikat);

Zmienne systemowe:

	SQL%ROWCOUNT		-	ilo zwrconych wierszy
	SQL%FOUND		-	czy zapytanie zwrcio wiersz
	SQLERRM			-	komunikat o bdzie

Uruchomienie procedury:

	EXECUTE procedura (parametry)

Zmienne typu wiersza i kolumny:

zmienna emp.ename%type		- zmienna tego samego typu co ename
zmienna emp%rowtype		- zmienna typu wierszowego

Deklaracja i uycie kursora:

	W DECLARE:
		CURSOR nazwa IS SELECT ...
	Po BEGIN:
		OPEN nazwa;				-	otwarcie kursora
		FETCH nazwa INTO zmienna;	-	cignicie kolejnego wiersza
		CLOSE nazwa;			-	zamknicie kursora

	Kursorw uywamy zwykle w ptli np.:
		LOOP
			FETCH nazwa INTO zmienna;
			EXIT WHEN nazwa%NOTFOUND;
			...
		END LOOP;

Atrybuty kursora:

	nazwa%FOUND		-	ostatnia instrukcja FETCH zwrcia wiersz
	nazwa%NOTFOUND	-	ostatnia instrukcja FETCH nie zwrcia wiersza
	nazwa%ROWCOUNT	-	ilo zwrconych dotychczas wierszy
	nazwa%ISOPEN		-	okrela, czy kursor jest otwarty

Procedury:

	CREATE [OR REPLACE] PROCEDURE nazwa (par [IN/OUT/INOUT] TYP, ...) AS
		deklaracje
	BEGIN
		kod procedury
	END;

Funkcje:

	CREATE [OR REPLACE] FUNCTION nazwa (par [IN/OUT/INOUT] TYP, ...)
	RETURN TYP AS
		deklaracje
	BEGIN
		kod funkcji
		RETURN wyraenie;
	END;

Wyzwalacze:

	CREATE [OR REPLACE] TRIGGER nazwa
	{BEFORE / AFTER} specyfikacja instrukcji
	ON tabela
	[FOR EACH ROW]
	blok PL/SQL

Specyfikacje instrukcji:
	INSERT, DELETE, UPDATE
	Mona je czy np. BEFORE INSERT OR UPDATE
Dla UPDATE mona okreli pola, ktrych modyfikowanie spowoduje uruchomienie triggera np. UPDATE OF pole1, pole2

Odwoanie do starej/nowej wartoci w wyzwalaczu:

	:OLD.pole
	:NEW.pole

Zmienne logiczne okrelajce, co spowodowao uruchomienie wyzwalacza:

	UPDATING, INSERTING, DELETING

Tworzenie sekwensji:

	CREATE SEQUENCE nazwa_sekwencji
	[INCREMENT BY k]
	[START WITH n]

Bieca i kolejna wartoci sekwencji:

	nazwa_sekwencji.currval
	nazwa_sekwencji.nextval
