-- 1.	Wypisz goci wraz z liczb dokonanych przez nich rezerwacji. 
-- 		Nie wypisuj informacji o gociach, ktrzy zoyli tylko jedn rezerwacj.
select imie,nazwisko,c from Gosc g, (
	select [IdGosc], count(*) as c from [dbo].[Rezerwacja] group by [IdGosc] having count(*) > 1
) as cnt 
where g.IdGosc = cnt.IdGosc;

-- 2.	Wypisz pokoje o najwikszej liczbie miejsc.
select * from pokoj where Liczba_miejsc >= all( select Liczba_miejsc from pokoj )
select * from pokoj where Liczba_miejsc = ( select max(Liczba_miejsc) from pokoj )

-- 3.	Dla kadego pokoju wypisz, kiedy by ostatnio wynajmowany.
select NrPokoju,dataOd from rezerwacja r where dataOd > any( select dataOd from Rezerwacja where NrPokoju=r.NrPokoju )

-- 4.	Wypisz liczb rezerwacji dla kadego pokoju. 
-- 		Nie wypisuj pokoi, ktre byy rezerwowane tylko raz oraz pokoi z kategorii luksusowy.
select r.nrPokoju, ( select count(*) from rezerwacja r2 where r2.NrPokoju = p.NrPokoju) as c
from Rezerwacja r, pokoj p, kategoria k
where ( r.NrPokoju = p.NrPokoju and p.idkategoria = k.IdKategoria )
and lower(k.Nazwa) <> 'luksusowy' and
( select count(*) from rezerwacja r2 where r2.NrPokoju = p.NrPokoju ) > 1

-- 5.	Podaj dane (imi, nazwisko, numer pokoju) najnowszej rezerwacji.
select imie,nazwisko,NrPokoju from gosc g, rezerwacja r where r.IdGosc = g.IdGosc 
and r.DataOd = ( select max(dataod) from rezerwacja )
and r.DataDo = ( select max(datado) from rezerwacja )

-- 6.	Wypisz dane pokoju, ktry nie by nigdy wynajmowany.
select * from pokoj where not exists( 
	select IdRezerwacja from Rezerwacja where NrPokoju = Pokoj.NrPokoju 
)

-- 7.	Uywajc operatora NOT EXISTS wypisz goci, ktrzy nigdy nie wynajmowali pokoju luksusowego.
select * from gosc g where not exists ( 
	select idrezerwacja from rezerwacja r, kategoria k, pokoj p 
	where r.NrPokoju = p.NrPokoju and p.idkategoria = k.idkategoria 
	and r.idgosc = g.idgosc
	and not lower(k.Nazwa) = 'luksusowy'
)

-- 8.	W jednym zapytaniu wypisz goci, ktrzy wynajmowali pokj 101 
-- 		(imi, nazwisko, data rezerwacji) 
-- 		oraz goci, ktrzy nigdy nie wynajmowali adnego pokoju (imi, nazwisko, brak).
select imie,nazwisko, coalesce( cast( r.NrPokoju as varchar) ,'brak' )  from gosc g
left join rezerwacja r on r.idgosc = g.idgosc
where r.NrPokoju = 101 or r.NrPokoju is null
/*
select imie,nazwisko from gosc g where (
	exists ( select idrezerwacja from rezerwacja r where g.idgosc = r.idgosc and r.NrPokoju = 101 )
	or
	not exists( select idrezerwacja from rezerwacja r where g.idgosc = r.idgosc )
)
*/
-- 9.	Znajd kategori, w ktrej liczba pokoi jest najwiksza.
select k.idkategoria, count(*) 
from kategoria k, pokoj p 
where p.IdKategoria = k.idkategoria 
group by k.idkategoria
having count(*) > any( 
	select count(*) from kategoria k, pokoj p 
	where p.IdKategoria = k.idkategoria group by k.idkategoria 
)

-- 10.	Dla kadej kategorii podaj pokj o najwikszej liczbie miejsc.
select p.NrPokoju, p.liczba_miejsc, k.nazwa 
from pokoj p, kategoria k 
where 	p.idkategoria = k.idkategoria 
	and p.Liczba_miejsc > any( 
		select Liczba_miejsc 
		from pokoj p2, kategoria k2 
		where 	k2.idkategoria = p2.IdKategoria 
		and 	k2.IdKategoria = k.IdKategoria
	)